;Predefined object types
__DEFINE_GUID("GUID_XAxis", 0xA36D02E0, 0xC9F3, 0x11CF, 0xBF, 0xC7, 0x44, 0x45, 0x53, 0x54, 0x00, 0x00);
__DEFINE_GUID("GUID_YAxis", 0xA36D02E1, 0xC9F3, 0x11CF, 0xBF, 0xC7, 0x44, 0x45, 0x53, 0x54, 0x00, 0x00);
__DEFINE_GUID("GUID_ZAxis", 0xA36D02E2, 0xC9F3, 0x11CF, 0xBF, 0xC7, 0x44, 0x45, 0x53, 0x54, 0x00, 0x00);
__DEFINE_GUID("GUID_RxAxis", 0xA36D02F4, 0xC9F3, 0x11CF, 0xBF, 0xC7, 0x44, 0x45, 0x53, 0x54, 0x00, 0x00);
__DEFINE_GUID("GUID_RyAxis", 0xA36D02F5, 0xC9F3, 0x11CF, 0xBF, 0xC7, 0x44, 0x45, 0x53, 0x54, 0x00, 0x00);
__DEFINE_GUID("GUID_RzAxis", 0xA36D02E3, 0xC9F3, 0x11CF, 0xBF, 0xC7, 0x44, 0x45, 0x53, 0x54, 0x00, 0x00);
__DEFINE_GUID("GUID_Slider", 0xA36D02E4, 0xC9F3, 0x11CF, 0xBF, 0xC7, 0x44, 0x45, 0x53, 0x54, 0x00, 0x00);
__DEFINE_GUID("GUID_Button", 0xA36D02F0, 0xC9F3, 0x11CF, 0xBF, 0xC7, 0x44, 0x45, 0x53, 0x54, 0x00, 0x00);
__DEFINE_GUID("GUID_Key", 0x55728220, 0xD33C, 0x11CF, 0xBF, 0xC7, 0x44, 0x45, 0x53, 0x54, 0x00, 0x00);
__DEFINE_GUID("GUID_POV", 0xA36D02F2, 0xC9F3, 0x11CF, 0xBF, 0xC7, 0x44, 0x45, 0x53, 0x54, 0x00, 0x00);
;__DEFINE_GUID("GUID_Unknown", 			0xA36D02F3, 0xC9F3, 0x11CF, 0xBF, 0xC7, 0x44, 0x45, 0x53, 0x54, 0x00, 0x00);

__DEFINE_GUID("GUID_SysMouse", 0x6F1D2B60, 0xD5A0, 0x11CF, 0xBF, 0xC7, 0x44, 0x45, 0x53, 0x54, 0x00, 0x00);
__DEFINE_GUID("GUID_SysKeyboard", 0x6F1D2B61, 0xD5A0, 0x11CF, 0xBF, 0xC7, 0x44, 0x45, 0x53, 0x54, 0x00, 0x00);
;__DEFINE_GUID("GUID_Joystick"   ,		0x6F1D2B70, 0xD5A0, 0x11CF, 0xBF, 0xC7, 0x44, 0x45, 0x53, 0x54, 0x00, 0x00);
;__DEFINE_GUID("GUID_SysMouseEm", 		0x6F1D2B80, 0xD5A0, 0x11CF, 0xBF, 0xC7, 0x44, 0x45, 0x53, 0x54, 0x00, 0x00);
;__DEFINE_GUID("GUID_SysMouseEm2",		0x6F1D2B81, 0xD5A0, 0x11CF, 0xBF, 0xC7, 0x44, 0x45, 0x53, 0x54, 0x00, 0x00);
;__DEFINE_GUID("GUID_SysKeyboardEm", 	0x6F1D2B82, 0xD5A0, 0x11CF, 0xBF, 0xC7, 0x44, 0x45, 0x53, 0x54, 0x00, 0x00);
;__DEFINE_GUID("GUID_SysKeyboardEm2",	0x6F1D2B83, 0xD5A0, 0x11CF, 0xBF, 0xC7, 0x44, 0x45, 0x53, 0x54, 0x00, 0x00);

; #FUNCTION# ===========================================================================================================
; Name ..........: __DEFINE_GUID
; Description ...:
; Syntax ........: __DEFINE_GUID($sGuid, $d1, $d2, $d3, $d4, $d5, $d6, $d7, $d8, $d9, $d10, $d11)
; Parameters ....: $sGuid               - A string value.
;                  $d1                  - An integer value, part of GUID.
;                  $d2                  - An integer value, part of GUID.
;                  $d3                  - An integer value, part of GUID.
;                  $d4                  - An integer value, part of GUID.
;                  $d5                  - An integer value, part of GUID.
;                  $d6                  - An integer value, part of GUID.
;                  $d7                  - An integer value, part of GUID.
;                  $d8                  - An integer value, part of GUID.
;                  $d9                  - An integer value, part of GUID.
;                  $d10                 - An integer value, part of GUID.
;                  $d11                 - An integer value, part of GUID.
; Return values .: None
; Author ........: Thierry Kielbasiewicz
; Modified ......:
; Remarks .......: Create Global var: tGUID_XAxis, tGUID_YAxis etc    (Assign is used)
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func __DEFINE_GUID($sGuid, $d1, $d2, $d3, $d4, $d5, $d6, $d7, $d8, $d9, $d10, $d11)
	Local $tGuid = "t" & $sGuid
	If IsDeclared($tGuid) Then Return
	Local $var = "{" & Hex($d1, 8) & "-" & Hex($d2, 4) & "-" & Hex($d3, 4) & "-" & Hex($d4, 2) & Hex($d5, 2) & "-" & _
			Hex($d6, 2) & Hex($d7, 2) & Hex($d8, 2) & Hex($d9, 2) & Hex($d10, 2) & Hex($d11, 2) & "}"
	;	Assign($sGuid, $var, 2) ; uncomment if Guid string is needed
	Assign($tGuid, _WinAPI_GUIDFromString($var), 2)
EndFunc   ;==>__DEFINE_GUID

; #FUNCTION# ====================================================================================================================
; Name ..........: _Init_c_dfDIJoystick
; Description ...:
; Syntax ........: _Init_c_dfDIJoystick()
; Parameters ....:
; Return values .: Pointer on c_dfDIJoystick
; Author ........: Thierry Kielbasiewicz
; Modified ......:
; Remarks .......:;~ const DIDATAFORMAT c_dfDIJoystick =
;~ -        		/* dwSize =     */ 24,
;~ -        		/* dwObjSize =  */ 16,
;~ -        		/* dwFlags =    */ DIDF_ABSAXIS,
;~ -        		/* dwDataSize = */ 80,
;~ -        		/* dwNumObjs =  */ 44,
;~ -        		/* rgodf =      */ &diodfJoyData[0]
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _Init_c_dfDIJoystick()
	Local Const $NumObjs = 44
	Local $TAB_DIOBJECTDATA[$NumObjs][4] = [ _
			["GUID_XAxis", 0, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_AXIS), $DIDOI_ASPECTPOSITION], _
			["GUID_YAxis", 4, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_AXIS), $DIDOI_ASPECTPOSITION], _
			["GUID_ZAxis", 8, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_AXIS), $DIDOI_ASPECTPOSITION], _
			["GUID_RxAxis", 12, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_AXIS), $DIDOI_ASPECTPOSITION], _
			["GUID_RyAxis", 16, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_AXIS), $DIDOI_ASPECTPOSITION], _
			["GUID_RzAxis", 20, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_AXIS), $DIDOI_ASPECTPOSITION], _
			["GUID_Slider", 24, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_AXIS), $DIDOI_ASPECTPOSITION], _
			["GUID_Slider", 28, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_AXIS), $DIDOI_ASPECTPOSITION], _
			["GUID_POV", 32, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_POV), 0x00000000], _
			["GUID_POV", 36, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_POV), 0x00000000], _
			["GUID_POV", 40, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_POV), 0x00000000], _
			["GUID_POV", 44, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_POV), 0x00000000], _
			[0, 48, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0],[0, 49, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0], _
			[0, 50, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0],[0, 51, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0], _
			[0, 52, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0],[0, 53, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0], _
			[0, 54, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0],[0, 55, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0], _
			[0, 56, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0],[0, 57, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0], _
			[0, 58, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0],[0, 59, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0], _
			[0, 60, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0],[0, 61, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0], _
			[0, 62, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0],[0, 63, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0], _
			[0, 64, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0],[0, 65, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0], _
			[0, 66, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0],[0, 67, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0], _
			[0, 68, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0],[0, 69, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0], _
			[0, 70, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0],[0, 71, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0], _
			[0, 72, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0],[0, 73, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0], _
			[0, 74, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0],[0, 75, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0], _
			[0, 76, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0],[0, 77, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0], _
			[0, 78, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0],[0, 79, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0]]

	Global $stDIOBJJoy, $stDIDATAJoy
	Local $i, $g, $t, $v, $tagOBJ, $tagORI = ""
	$tagORI = StringReplace($tagDIOBJECTDATAFORMAT, ";", "$;")
	For $i = 1 To $NumObjs
		$tagOBJ = $tagOBJ & StringReplace($tagORI, "$", $i)
	Next

	$stDIOBJJoy = DllStructCreate($tagOBJ)
	For $i = 0 To $NumObjs - 1
		$g = $TAB_DIOBJECTDATA[$i][0]
		$t = "t" & $g
		$v = 0
		If $g Then $v = DllStructGetPtr(Eval($t))
		DllStructSetData($stDIOBJJoy, "pguid" & $i + 1, $v)
		DllStructSetData($stDIOBJJoy, "dwOfs" & $i + 1, $TAB_DIOBJECTDATA[$i][1])
		DllStructSetData($stDIOBJJoy, "dwType" & $i + 1, $TAB_DIOBJECTDATA[$i][2])
		DllStructSetData($stDIOBJJoy, "dwFlags" & $i + 1, $TAB_DIOBJECTDATA[$i][3])
		;		If Not $g Then ConsoleWrite($i+1 & "/" & $t & " / " & Eval($g) & "/" & @CRLF)
	Next
	$stDIDATAJoy = DllStructCreate($tagDIDATAFORMAT)
	DllStructSetData($stDIDATAJoy, "dwSize", _SIZEOF($stDIDATAJoy))
	DllStructSetData($stDIDATAJoy, "dwObjSize", _SIZEOF($stDIOBJJoy) / $NumObjs)
	DllStructSetData($stDIDATAJoy, "dwFlags", $DIDFT_ABSAXIS)
	DllStructSetData($stDIDATAJoy, "dwDataSize", 80)
	DllStructSetData($stDIDATAJoy, "dwNumObjs", $NumObjs)
	DllStructSetData($stDIDATAJoy, "rgodf", DllStructGetPtr($stDIOBJJoy))
	Return DllStructGetPtr($stDIDATAJoy)
EndFunc   ;==>_Init_c_dfDIJoystick


; #FUNCTION# ====================================================================================================================
; Name ..........: _Init_c_dfDIJoystick2
; Description ...:
; Syntax ........: _Init_c_dfDIJoystick2()
; Parameters ....:
; Return values .: Pointer on c_dfDIJoystick2
; Author ........: Thierry Kielbasiewicz
; Modified ......:
; Remarks .......:;~ const DIDATAFORMAT c_dfDIJoystick2 =
;~ -        		/* dwSize =     */ 24,
;~ -        		/* dwObjSize =  */ 16,
;~ -        		/* dwFlags =    */ DIDF_ABSAXIS,
;~ -        		/* dwDataSize = */ 272,
;~ -        		/* dwNumObjs =  */ 164,
;~ -        		/* rgodf =      */ &diodfJoy2Data[0]
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _Init_c_dfDIJoystick2()
	Local Const $NumObjs = 164
	Local $TAB_DIOBJECTDATA[$NumObjs][4] = [ _
			["GUID_XAxis", 0, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTPOSITION], _
			["GUID_YAxis", 4, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTPOSITION], _
			["GUID_ZAxis", 8, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTPOSITION], _
			["GUID_RxAxis", 12, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTPOSITION], _
			["GUID_RyAxis", 16, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTPOSITION], _
			["GUID_RzAxis", 20, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTPOSITION], _
			["GUID_Slider", 24, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTPOSITION], _
			["GUID_Slider", 28, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTPOSITION], _
			["GUID_POV", 32, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_POV, 0x00000000], _
			["GUID_POV", 36, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_POV, 0x00000000], _
			["GUID_POV", 40, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_POV, 0x00000000], _
			["GUID_POV", 44, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_POV, 0x00000000], _
			[0, 48, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 49, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 50, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 51, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 52, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 53, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 54, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 55, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 56, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 57, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 58, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 59, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 60, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 61, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 62, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 63, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 64, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 65, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 66, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 67, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 68, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 69, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 70, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 71, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 72, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 73, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 74, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 75, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 76, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 77, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 78, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 79, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 80, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 81, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 82, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 83, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 84, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 85, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 86, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 87, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 88, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 89, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 90, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 91, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 92, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 93, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 94, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 95, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 96, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 97, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 98, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 99, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 100, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 101, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 102, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 103, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 104, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 105, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 106, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 107, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 108, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 109, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 110, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 111, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 112, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 113, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 114, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 115, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 116, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 117, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 118, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 119, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 120, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 121, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 122, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 123, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 124, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 125, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 126, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 127, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 128, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 129, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 130, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 131, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 132, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 133, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 134, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 135, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 136, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 137, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 138, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 139, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 140, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 141, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 142, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 143, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 144, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 145, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 146, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 147, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 148, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 149, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 150, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 151, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 152, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 153, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 154, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 155, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 156, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 157, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 158, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 159, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 160, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 161, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 162, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 163, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 164, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 165, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 166, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 167, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 168, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 169, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 170, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 171, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 172, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 173, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			[0, 174, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0],[0, 175, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_BUTTON, 0], _
			["GUID_XAxis", 176, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTVELOCITY], _
			["GUID_YAxis", 180, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTVELOCITY], _
			["GUID_ZAxis", 184, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTVELOCITY], _
			["GUID_RxAxis", 188, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTVELOCITY], _
			["GUID_RyAxis", 192, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTVELOCITY], _
			["GUID_RzAxis", 196, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTVELOCITY], _
			["GUID_Slider", 24, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTVELOCITY], _
			["GUID_Slider", 28, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTVELOCITY], _
			["GUID_XAxis", 208, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTACCEL], _
			["GUID_YAxis", 212, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTACCEL], _
			["GUID_ZAxis", 216, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTACCEL], _
			["GUID_RxAxis", 220, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTACCEL], _
			["GUID_RyAxis", 224, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTACCEL], _
			["GUID_RzAxis", 228, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTACCEL], _
			["GUID_Slider", 24, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTACCEL], _
			["GUID_Slider", 28, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTACCEL], _
			["GUID_XAxis", 240, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTFORCE], _
			["GUID_YAxis", 244, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTFORCE], _
			["GUID_ZAxis", 248, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTFORCE], _
			["GUID_RxAxis", 252, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTFORCE], _
			["GUID_RyAxis", 256, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTFORCE], _
			["GUID_RzAxis", 260, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTFORCE], _
			["GUID_Slider", 24, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTFORCE], _
			["GUID_Slider", 28, $DIDFT_OPTIONAL + $DIDFT_ANYINSTANCE + $DIDFT_AXIS, $DIDOI_ASPECTFORCE]]

	Global $stDIOBJJoy, $stDIDATAJoy
	Local $i, $g, $t, $v, $tagOBJ, $tagORI = ""
	$tagORI = StringReplace($tagDIOBJECTDATAFORMAT, ";", "$;")
	For $i = 1 To $NumObjs
		$tagOBJ = $tagOBJ & StringReplace($tagORI, "$", $i)
	Next

	$stDIOBJJoy = DllStructCreate($tagOBJ)
	For $i = 0 To $NumObjs - 1
		$g = $TAB_DIOBJECTDATA[$i][0]
		$t = "t" & $g
		$v = 0
		If $g Then $v = DllStructGetPtr(Eval($t))
		DllStructSetData($stDIOBJJoy, "pguid" & $i + 1, $v)
		DllStructSetData($stDIOBJJoy, "dwOfs" & $i + 1, $TAB_DIOBJECTDATA[$i][1])
		DllStructSetData($stDIOBJJoy, "dwType" & $i + 1, $TAB_DIOBJECTDATA[$i][2])
		DllStructSetData($stDIOBJJoy, "dwFlags" & $i + 1, $TAB_DIOBJECTDATA[$i][3])
		;		If Not $g Then ConsoleWrite($i+1 & "/" & $t & " / " & Eval($g) & "/" & @CRLF)
	Next
	$stDIDATAJoy = DllStructCreate($tagDIDATAFORMAT)
	DllStructSetData($stDIDATAJoy, "dwSize", _SIZEOF($stDIDATAJoy))
	DllStructSetData($stDIDATAJoy, "dwObjSize", _SIZEOF($stDIOBJJoy) / $NumObjs)
	DllStructSetData($stDIDATAJoy, "dwFlags", $DIDFT_ABSAXIS)
	DllStructSetData($stDIDATAJoy, "dwDataSize", 80)
	DllStructSetData($stDIDATAJoy, "dwNumObjs", $NumObjs)
	DllStructSetData($stDIDATAJoy, "rgodf", DllStructGetPtr($stDIOBJJoy))
	Return DllStructGetPtr($stDIDATAJoy)
EndFunc   ;==>_Init_c_dfDIJoystick2

; #FUNCTION# ====================================================================================================================
; Name ..........: _Init_c_dfDIMouse
; Description ...:
; Syntax ........: _Init_c_dfDIMouse()
; Parameters ....:
; Return values .: Pointer on c_dfDIMouse
; Author ........: Thierry Kielbasiewicz
; Modified ......:
; Remarks .......:;~ const DIDATAFORMAT c_dfDIMouse =
;~ -        		/* dwSize =     */ 24,
;~ -        		/* dwObjSize =  */ 16,
;~ -        		/* dwFlags =    */ DIDF_RELAXIS,
;~ -        		/* dwDataSize = */ 16,
;~ -        		/* dwNumObjs =  */ 7,
;~ -        		/* rgodf =      */ &diodfmouseData[0]
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _Init_c_dfDIMouse()
	Local Const $NumObjs = 7
	Local $TAB_DIOBJECTDATA[$NumObjs][4] = [ _
			["GUID_XAxis", 0, BitOR($DIDFT_ANYINSTANCE, $DIDFT_AXIS), 0], _
			["GUID_YAxis", 4, BitOR($DIDFT_ANYINSTANCE, $DIDFT_AXIS), 0], _
			["GUID_ZAxis", 8, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_AXIS), 0], _
			[0, 12, BitOR($DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0],[0, 13, BitOR($DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0], _
			[0, 14, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0],[0, 15, BitOR($DIDFT_OPTIONAL, $DIDFT_ANYINSTANCE, $DIDFT_BUTTON), 0]]

	Global $stDIOBJMouse, $stDIDATAMouse, $stDIMOUSESTATE
	Local $i, $g, $t, $v, $tagOBJ, $tagORI = ""
	$tagORI = StringReplace($tagDIOBJECTDATAFORMAT, ";", "$;")
	For $i = 1 To $NumObjs
		$tagOBJ = $tagOBJ & StringReplace($tagORI, "$", $i)
	Next

	$stDIOBJMouse = DllStructCreate($tagOBJ)
	For $i = 0 To $NumObjs - 1
		$g = $TAB_DIOBJECTDATA[$i][0]
		$t = "t" & $g
		$v = 0
		If $g Then $v = DllStructGetPtr(Eval($t))
		DllStructSetData($stDIOBJMouse, "pguid" & $i + 1, $v)
		DllStructSetData($stDIOBJMouse, "dwOfs" & $i + 1, $TAB_DIOBJECTDATA[$i][1])
		DllStructSetData($stDIOBJMouse, "dwType" & $i + 1, $TAB_DIOBJECTDATA[$i][2])
		DllStructSetData($stDIOBJMouse, "dwFlags" & $i + 1, $TAB_DIOBJECTDATA[$i][3])
		;		If Not $g Then ConsoleWrite($i+1 & "/" & $t & " / " & Eval($g) & "/" & @CRLF)
	Next
	$stDIDATAMouse = DllStructCreate($tagDIDATAFORMAT)
	DllStructSetData($stDIDATAMouse, "dwSize", _SIZEOF($stDIDATAMouse))
	DllStructSetData($stDIDATAMouse, "dwObjSize", _SIZEOF($stDIOBJMouse) / $NumObjs)
	DllStructSetData($stDIDATAMouse, "dwFlags", $DIDFT_RELAXIS)
	DllStructSetData($stDIDATAMouse, "dwDataSize", 16)
	DllStructSetData($stDIDATAMouse, "dwNumObjs", $NumObjs)
	DllStructSetData($stDIDATAMouse, "rgodf", DllStructGetPtr($stDIOBJMouse))
	Return DllStructGetPtr($stDIDATAMouse)
EndFunc   ;==>_Init_c_dfDIMouse
; #FUNCTION# ====================================================================================================================
; Name ..........: _Init_c_dfDIKeyboard
; Description ...:
; Syntax ........: _Init_c_dfDIKeyboard()
; Parameters ....:
; Return values .: Pointer on c_dfDIKeyboard
; Author ........: Thierry Kielbasiewicz
; Modified ......:
; Remarks .......:;~ const DIDATAFORMAT c_dfDIKeyboard =
;~ -        		/* dwSize =     */ 24,
;~ -        		/* dwObjSize =  */ 16,
;~ -        		/* dwFlags =    */ DIDF_RELAXIS,
;~ -        		/* dwDataSize = */ 256,
;~ -        		/* dwNumObjs =  */ 256,
;~ -        		/* rgodf =      */ &diodfKeyData[0]
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _Init_c_dfDIKeyboard()
	Local Const $NumObjs = 256
	Local $TAB_DIOBJECTDATA[$NumObjs][4];
	For $i = 0 To $NumObjs - 1
		$TAB_DIOBJECTDATA[$i][0] = "GUID_Key"
		$TAB_DIOBJECTDATA[$i][1] = $i
		$TAB_DIOBJECTDATA[$i][2] = BitOR($DIDFT_OPTIONAL, $DIDFT_BUTTON, _DIDFT_MAKEINSTANCE($i))
		$TAB_DIOBJECTDATA[$i][3] = 0
	Next

	Global $stDIOBJKeyboard, $stDIDATAKeyboard, $stDIKEYBOARDSTATE
	Local $i, $g, $t, $v, $tagOBJ, $tagORI = ""
	$tagORI = StringReplace($tagDIOBJECTDATAFORMAT, ";", "$;")
	For $i = 1 To $NumObjs
		$tagOBJ = $tagOBJ & StringReplace($tagORI, "$", $i)
	Next

	$stDIOBJKeyboard = DllStructCreate($tagOBJ)
	For $i = 0 To $NumObjs - 1
		$g = $TAB_DIOBJECTDATA[$i][0]
		$t = "t" & $g
		$v = 0
		If $g Then $v = DllStructGetPtr(Eval($t))
		DllStructSetData($stDIOBJKeyboard, "pguid" & $i + 1, $v)
		DllStructSetData($stDIOBJKeyboard, "dwOfs" & $i + 1, $TAB_DIOBJECTDATA[$i][1])
		DllStructSetData($stDIOBJKeyboard, "dwType" & $i + 1, $TAB_DIOBJECTDATA[$i][2])
		DllStructSetData($stDIOBJKeyboard, "dwFlags" & $i + 1, $TAB_DIOBJECTDATA[$i][3])
	Next

	$stDIDATAKeyboard = DllStructCreate($tagDIDATAFORMAT)
	DllStructSetData($stDIDATAKeyboard, "dwSize", _SIZEOF($stDIDATAKeyboard)) ;_SIZEOF($tagDIDATAFORMAT)) 24
	DllStructSetData($stDIDATAKeyboard, "dwObjSize", _SIZEOF($stDIOBJKeyboard) / $NumObjs) ;_SIZEOF($tagDIOBJECTDATAFORMAT)) 16
	DllStructSetData($stDIDATAKeyboard, "dwFlags", $DIDFT_RELAXIS)
	DllStructSetData($stDIDATAKeyboard, "dwDataSize", 256) ;_SIZEOF($tagDIKEYBOARDSTATE))
	DllStructSetData($stDIDATAKeyboard, "dwNumObjs", $NumObjs)
	DllStructSetData($stDIDATAKeyboard, "rgodf", DllStructGetPtr($stDIOBJKeyboard))
	Return DllStructGetPtr($stDIDATAKeyboard)
EndFunc   ;==>_Init_c_dfDIKeyboard

; #FUNCTION# ====================================================================================================================
; Name ..........: _DIDFT_MAKEINSTANCE
; Description ...:
; Syntax ........: _DIDFT_MAKEINSTANCE($iN)
; Parameters ....: $iN                  - An integer value.
; Return values .: None
; Author ........: Thierry Kielbasiewicz
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _DIDFT_MAKEINSTANCE($iN)
	Return BitShift($iN, -8)
EndFunc   ;==>_DIDFT_MAKEINSTANCE

; #FUNCTION# ====================================================================================================================
; Name ..........: _SIZEOF
; Description ...:
; Syntax ........: _SIZEOF($sT)
; Parameters ....: $sT                  - A struct value.
; Return values .: None
; Author ........: Thierry Kielbasiewicz
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _SIZEOF($sT)
	Return DllStructGetSize($sT)
EndFunc   ;==>_SIZEOF

; #FUNCTION# ====================================================================================================================
; Name...........: _WinAPI_GUIDFromString
; Description ...: Converts a string GUID to binary form
; Syntax.........: _WinAPI_GUIDFromString($sGUID)
; Parameters ....: $sGUID       - GUID in string form
; Return values .: Success      - $tagGUID structure
; Author ........: Paul Campbell (PaulIA)
; Modified.......:
; Remarks .......:
; Related .......: _WinAPI_StringFromGUID, $tagGUID
; Link ..........:
; Example .......:
; ===============================================================================================================================
Func _WinAPI_GUIDFromString($sGuid)
	Local $tGuid = DllStructCreate($tagGUID)
	_WinAPI_GUIDFromStringEx($sGuid, $tGuid)
	If @error Then Return SetError(@error, @extended, 0)
	Return $tGuid
EndFunc   ;==>_WinAPI_GUIDFromString

; #FUNCTION# ====================================================================================================================
; Name...........: _WinAPI_GUIDFromStringEx
; Description ...: Converts a string GUID to binary form
; Syntax.........: _WinAPI_GUIDFromStringEx($sGUID, $pGUID)
; Parameters ....: $sGUID       - GUID in string form
;                  $pGUID       - Pointer to a $tagGUID structure where the GUID will be stored
; Return values .: Success      - True
;                  Failure      - False
; Author ........: Paul Campbell (PaulIA)
; Modified.......:
; Remarks .......:
; Related .......: _WinAPI_StringFromGUID, $tagGUID
; Link ..........: @@MsdnLink@@ CLSIDFromString
; Example .......:
; ===============================================================================================================================
Func _WinAPI_GUIDFromStringEx($sGuid, $pGUID)
	Local $aResult = DllCall("ole32.dll", "long", "CLSIDFromString", "wstr", $sGuid, "struct*", $pGUID)
	If @error Then Return SetError(@error, @extended, False)
	Return $aResult[0]
EndFunc   ;==>_WinAPI_GUIDFromStringEx

